#include "netlib.h"
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <sys/timeb.h>
#include <ctype.h>
#define LSIZE   256
#define MAXLET  1000

char line[LSIZE];
struct let {
  long    adr;
  char    change;
} let[MAXLET];
int  nlet;
char mailfile[] = "netlib";
FILE *tmpf;
FILE *reqf;
FILE *malf;
int  locked;
char *curlock;
char  from[] = "From ";
int  delete();
int  (*setsig())();
char  *strcpy();
char  *strcat();
char  *ctime();
long  time();

main()
{
  struct stat buf;
  setsig(SIGINT, delete);
  setsig(SIGHUP, delete);
  setsig(SIGKILL, delete);
  chdir("/usr/spool/mail");
  for(;;){
    if( (stat(mailfile,&buf)==0) && (buf.st_size>0) ) scanmail();
    sleep(60);
    }
}

scanmail()
{
  int i;
  FILE *popen();

  tmpf = fopen(lettmp, "w");
  if(tmpf == NULL) fail("lettmp");
  malf = fopen(mailfile, "r");
  if (malf == NULL) fail("mailfile");
  if(!lock(mailfile)) return;
  copymt(malf, tmpf);
  fclose(malf);
  fclose(tmpf);
  /* truncate mailfile */
  malf=fopen(mailfile,"w");
  fclose(malf);
  unlock();
  tmpf = fopen(lettmp, "r");
  for (i=0; i<nlet; i++){
    reqf = popen("alias.scr", "w");
    if(reqf == NULL) fail("popen alias.scr");
    copylet(i,reqf);
    pclose(reqf);
    }
  fclose(tmpf);
}


copymt(f1, f2)  /* copy mail (f1) to temp (f2) */
FILE *f1, *f2;
{
  long nextadr;

  nlet = nextadr = 0;
  let[0].adr = 0;
  while (fgets(line, LSIZE, f1) != NULL) {
    if (isfrom(line)) {
      let[nlet++].adr = nextadr;
      if (nlet > MAXLET) fail("MAXLET");
    }
    nextadr += strlen(line);
    fputs(line, f2);
  }
  let[nlet].adr = nextadr;        /* last plus 1 */
}

copylet(n, f)
FILE *f;
{
  long k;
  register ch;

  fseek(tmpf, let[n].adr, 0);
  k = let[n+1].adr - let[n].adr;
  while (k>0) {
    ch = fgetc(tmpf);
    if (ch == EOF)
      break;
    fputc(ch, f);
    k--;
  }
}

isfrom(lp)
register char *lp;
{
  return(strncmp(lp, from, 5)==0);
}


lock(file)
char *file;
{
  struct stat stbuf;

  if (locked) return(1);
  if (stat(file, &stbuf)<0) return(1);
  if (stbuf.st_mode&01) {         /* user x bit is the lock */
    if (stbuf.st_ctime+60 >= time((long *)0)) { return(0); }
  }
  locked = stbuf.st_mode & ~01;
  curlock = file;
  chmod(file, stbuf.st_mode|01);
  return(1);
}

unlock()
{
  if (locked)
    chmod(curlock, locked);
  locked = 0;
}

fail(s)
  char *s;
{
  unlock();
  fprintf(stderr,"netlib: %s fail",s);
  exit(1);
}

delete(i)
{
  unlock();
  fail("signal");
}

int (*setsig(i, f))()
int i;
int (*f)();
{
  register int (*rc)();

  if ((rc = signal(i, SIG_IGN))!=SIG_IGN)
    signal(i, f);
  return(rc);
}

